<?php

/* Канал - https://t.me/swiftcms */
/* Автор - tiqix */
/* Тема - https://bym.guru/forum/topic/159786 */

require_once($_SERVER["DOCUMENT_ROOT"].'/swift/config.php');
require_once($_SERVER["DOCUMENT_ROOT"].'/swift/header.php');

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    
    $email = sanitize($_POST['email']);
    $nick = sanitize($_POST['nick']);
    $password = $_POST['password'];
    $password2 = $_POST['password2'];

    if (!filter_var($email, FILTER_VALIDATE_EMAIL)) die("Некоректна пошта");
    if (!preg_match("/^[a-zA-Z0-9]+$/", $nick)) die("Некоректний нік");
    if ($password !== $password2) die("Паролі не співпадають");

    // Перевірка, чи є вже такий нік або пошта
    $stmt = $pdo->prepare("SELECT COUNT(*) FROM users WHERE nick = ? OR email = ?");
    $stmt->execute([$nick, $email]);
    $exists = $stmt->fetchColumn();
    
    if ($exists > 0) die("Такий нік або email вже використовується");

    $hash = password_hash($password, PASSWORD_DEFAULT);
    $token = generateToken();
    
    $stmt = $pdo->prepare("INSERT INTO users (nick, email, password, token) VALUES (?, ?, ?, ?)");
    $stmt->execute([$nick, $email, $hash, $token]);
    setcookie("token", $token, time() + 31536000, "/");
    header("Location: index.php");
}
?>

<div class="form">
    <div class="login_text">
        <div class="login_title">Добро пожаловать 👋</div>
        Этот сайт работает на SwiftCMS.<br> Свободный код – свободный мир!
    </div>
    <form method="POST">
        <input type="text" name="nick" placeholder="Ник" required>
        <input type="email" name="email" placeholder="Email" required>
        <input type="password" name="password" placeholder="Пароль" required>
        <input type="password" name="password2" placeholder="Повторите пароль" required>
        <button type="submit">Регистрация</button>
    </form>
    <div class="pod_text">
        Уже есть аккаунт? <a href="/login.php">Ввойти</a>
    </div>
</div>
<?php

require_once($_SERVER["DOCUMENT_ROOT"].'/swift/footer.php');

?>