<?php

/* Канал - https://t.me/swiftcms */
/* Автор - tiqix */
/* Тема - https://bym.guru/forum/topic/159786 */

header('Content-Type: image/png; charset=utf-8');
header('Cache-Control: no-store, no-cache, must-revalidate, max-age=0');

// Проверка и очистка входных данных
$color = isset($_GET['color']) ? max(1, min(5, (int)$_GET['color'])) : 1;
$latter = isset($_GET['latter']) ? mb_strtoupper(mb_substr($_GET['latter'], 0, 1, 'UTF-8'), 'UTF-8') : '';

// Градиенты
$gradients = [
    ['#8AFF63', '#00B743'], ['#636EFF', '#0009B7'], ['#FF6363', '#B70000'], ['#FF63C6', '#B7006E'], ['#FFF263', '#B7AE00']
];
$gradient = $gradients[$color - 1];

// Создание изображения
$image = imagecreatetruecolor(100, 100);
list($r1, $g1, $b1) = array_map('hexdec', str_split(substr($gradient[0], 1), 2));
list($r2, $g2, $b2) = array_map('hexdec', str_split(substr($gradient[1], 1), 2));

// Заливка градиентом
for ($y = 0; $y < 100; $y++) {
    $r = $r1 + ($r2 - $r1) * ($y / 100);
    $g = $g1 + ($g2 - $g1) * ($y / 100);
    $b = $b1 + ($b2 - $b1) * ($y / 100);
    imageline($image, 0, $y, 100, $y, imagecolorallocate($image, $r, $g, $b));
}

// Добавление буквы
if ($latter) {
    $font = $_SERVER['DOCUMENT_ROOT'] . '/static/Montserrat-Medium.ttf';
    $white = imagecolorallocate($image, 255, 255, 255);
    $fontSize = 30;
    $bbox = imagettfbbox($fontSize, 0, $font, $latter);
    $x = (100 - ($bbox[2] - $bbox[0])) / 2;
    $y = (100 + ($bbox[1] - $bbox[7])) / 2;
    imagettftext($image, $fontSize, 0, $x, $y, $white, $font, $latter);
}

// Вывод изображения
imagepng($image);
imagedestroy($image);
exit;
